﻿// playAudioSample.cpp : このファイルには 'main' 関数が含まれています。プログラム実行の開始と終了がそこで行われます。
//
#define _WINSOCK_DEPRECATED_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <winsock2.h>
#include <atlstr.h>
using namespace std;

// CGIアドレスと音声ファイル
#define WRLP_URL       "/camera-cgi/audio/transmit.cgi"
#define WRLP_FILENAME  "output322.aac"
#define NA2XX_URL      "/1/camera-cgi/audio/transmit.cgi"
#define NA2XX_FILENAME "sine.gsm"

CString URL, FILENAME;
int type = 0;

// ソケット接続
SOCKET connectSocket( const char* server, char* servicename, short int service )
{
	WSADATA wsaData;
	LPHOSTENT lpHost;
	LPSERVENT lpServ;
	SOCKET sock;
	SOCKADDR_IN sockAddr;
	int port, status;

	// winsock ver1.1
	status = WSAStartup( MAKEWORD(1, 1), &wsaData );
	if( status != 0 ) {
		return INVALID_SOCKET;
	}

	// サーバ名からホスト取得
	lpHost = gethostbyname( server );
	if( lpHost == NULL ) {
		WSACleanup();
		return INVALID_SOCKET;
	}

	// サービス名からポート番号取得
	lpServ = getservbyname( servicename, NULL );
	if( lpServ == NULL ) {
		port = htons( service );
	} else {
		port = lpServ->s_port;
	}

	// ソケット開く
	sock = socket(PF_INET, SOCK_STREAM, 0);
	if (sock == INVALID_SOCKET) {
		WSACleanup();
		return INVALID_SOCKET;
	}

	// ソケット結合
	sockAddr.sin_family = AF_INET;
	sockAddr.sin_port = port;
	sockAddr.sin_addr = *( (LPIN_ADDR)* lpHost->h_addr_list );
	status = connect( sock, (PSOCKADDR)& sockAddr, sizeof(SOCKADDR_IN) );
	if( status ){
		closesocket( sock );
		WSACleanup();
		return INVALID_SOCKET;
	}
	return sock;
}

// 送信
void sendData( SOCKET s, char* data,  int size )
{
	send( s, data, size, 0 );
}

// 受信
int receiveData( SOCKET s, char* databuff, int buffsize )
{
	char* p = databuff;
	for( int i=0; i < buffsize; i++ ) * p++ = 0;
	return recv( s, databuff, buffsize, 0 );
}

// MD5計算
#define MD5LEN  16
CString MD5( CString text )
{
	DWORD dwStatus = 0, datasize = 0, cHash = 0;
	HCRYPTPROV hProv = 0;
	HCRYPTHASH hHash = 0;
	BYTE data[2048], bHash[MD5LEN];

	datasize = text.GetLength();
	WideCharToMultiByte( CP_ACP, 0, text, -1, (LPSTR)data, sizeof(data), NULL, NULL );

	// Get handle to the crypto provider
	if( !CryptAcquireContext(&hProv, NULL, NULL, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT) ) {
		dwStatus = GetLastError();
		return "";
	}

	if( !CryptCreateHash(hProv, CALG_MD5, 0, 0, &hHash) ) {
		dwStatus = GetLastError();
		CryptReleaseContext(hProv, 0);
		return "";
	}

	CHAR bDigit[] = "0123456789abcdef";
	char buf[8];
	CString md5;
	if( CryptHashData(hHash, data, datasize, 0) ) {
		cHash = MD5LEN;
		if( CryptGetHashParam(hHash, HP_HASHVAL, bHash, &cHash, 0) ) {
			for( DWORD i = 0; i < cHash; i++ ) {
				sprintf_s( buf, "%c%c", bDigit[bHash[i] >> 4], bDigit[bHash[i] & 0xf] );
				md5 += buf;
			}
		} else {
			dwStatus = GetLastError();
		}
	}
	CryptDestroyHash( hHash );
	CryptReleaseContext( hProv, 0 );

	return md5;
}

// Digest認証文字列作成
CString calcDigestResponse( CString nonse, CString user, CString pass )
{
	CString f1 = user + ":Network Camera:" + pass;
	CString f2 = "GET:" + URL;
	CString res = MD5( MD5(f1) + ":" + nonse + ":00000001:0123456789abcdef:auth:" + MD5(f2) );
	return res;
}

// 音声送信
void playAudio( CString destip, CString destpass )
{
	CString command;
	bool m_exitthread = false;

	char ipaddr[16];
	WideCharToMultiByte( CP_ACP, 0, destip, -1, ipaddr, sizeof(ipaddr), NULL, NULL );

	SOCKET sock;
	static char sndBuf[4096], rcvBuf[4096];

	// ソケットを開く
	sock = connectSocket( ipaddr, (char *)"http", 80 );
	if( sock == INVALID_SOCKET ) {
		printf( "Connect Socket Fail.\n" );
		return;
	}
	printf( "Connect Socket Success.\n" );
	Sleep( 1000 );

	// リクエスト作成
	CString nonce = "";
RETRY:
	command = "GET " + URL + " HTTP/1.1\r\nConnection: Keep-Alive\r\nCache-Control: no-cache";
	if (!nonce.IsEmpty()) {
		CString response = calcDigestResponse(nonce, "admin", destpass);
		command += "\r\nAuthorization: Digest username=\"admin\", realm=\"Network Camera\", nonce=" + nonce + ", uri=\"" + URL + "\"";
		command += ", response=\"" + response + "\", qop=\"auth\", nc=00000001, cnonce=\"0123456789abcdef\"\r\n";
	}
	command += "\r\n\r\n\r\n";

	WideCharToMultiByte(CP_ACP, 0, command, -1, sndBuf, sizeof(sndBuf), NULL, NULL);

	// リクエスト送信
	sendData( sock, sndBuf, strlen(sndBuf) );
	Sleep( 300 );

	// 応答受信
	receiveData( sock, rcvBuf, 4096 );
	Sleep( 100 );

	command = rcvBuf;
	if( command.Find( L"401 Unauthorized" ) > 0 ) {
		// 認証エラーの場合、取得したHTMLからnonce抽出
		if( nonce.IsEmpty() ) {
			int pos1 = command.Find( L"nonce=", 0 ) + 6 + 1;
			int pos2 = command.Find( L"\"", pos1 );
			if( pos1 > 0 ) {
				nonce = command.Mid(pos1, pos2 - pos1);
			}
			goto RETRY;
		} else {
			printf( "Fail: 401 Unauthorized.\n" );
			return;
		}
	} else if( command.Find(L"200 OK") > 0 ) {
		// 認証成功
		fstream file;

		file.open( FILENAME, ios::in | ios::binary );
		if( file ) {
			// スレッド優先度を上げる
			HANDLE hProcess = GetCurrentProcess();
			SetPriorityClass( hProcess, REALTIME_PRIORITY_CLASS );

			LARGE_INTEGER nFreq, nBefore, nAfter;
			memset( &nFreq, 0x00, sizeof nFreq );
			memset( &nBefore, 0x00, sizeof nBefore );
			memset( &nAfter, 0x00, sizeof nAfter );
			QueryPerformanceFrequency( &nFreq );

			// wait:送信の間隔ms, size:1回あたりの送信バイト数(33byteの倍数)
			DWORD dwTime = 0, wait, size;
			if( type == 1) {
				wait = 20; size = 330;
			} else {
				wait = 30; size = 132;
			}

			char gbuf[330];
			while( !file.eof() && !m_exitthread ) {
				// 音声データをsizeバイトずつ送信
				file.read( (char*)&gbuf, size );
				sendData( sock, gbuf, size );

				// wait(ms)の間待機する
				QueryPerformanceCounter( &nBefore );
				do {
					QueryPerformanceCounter( &nAfter );
					if( nAfter.QuadPart < nBefore.QuadPart ) {
						dwTime = (DWORD)( (nAfter.QuadPart - nBefore.QuadPart) * 1000 / nFreq.QuadPart );
					} else {
						dwTime = (DWORD)( ((LLONG_MAX - nBefore.QuadPart) + nAfter.QuadPart) * 1000 / nFreq.QuadPart );
					}

					if( dwTime > wait ) {
						break;
					}
				} while( !m_exitthread );

			}
			file.close();

			// スレッド優先度を戻す
			SetPriorityClass( hProcess, NORMAL_PRIORITY_CLASS );
		}
	}
	else {
		printf("Fail: 404 Notfound.\n");
	}

	// 後処理
	m_exitthread = true;
	closesocket( sock );
	WSACleanup();
}

// main
int main()
{
	std::cout << "カメラのタイプを選択してください：\n";
	std::cout << "1:TS-WRLP 2:TS-NA2XX\n";
	cin >> type;

	if (type == 1) {
		URL = WRLP_URL;
		FILENAME = WRLP_FILENAME;
	} else if (type == 2) {
		URL = NA2XX_URL;
		FILENAME = NA2XX_FILENAME;
	} else {
		printf("Fail: Invalid No.\n");
		return 1;
	}

	string destip, destpass;
	std::cout << "カメラのIPアドレスを入力してください：\n";
	cin >> destip;
	std::cout << "カメラのパスワードを入力してください：\n";
	cin >> destpass;

	playAudio( destip.c_str(), destpass.c_str() );
	return 0;
}
